package de.ipk_gatersleben.ag_pbi.fluxbalance.calculation;

import java.util.ArrayList;
import java.util.Collection;

import org.graffiti.plugin.algorithm.Algorithm;

import de.ipk_gatersleben.ag_nw.graffiti.plugins.gui.launch_gui.LaunchGui;

public class StartCalculationSelection extends LaunchGui implements Algorithm {

	public StartCalculationSelection() {
		super();
		algBTsize = ButtonSize.LARGE;
	}

	@Override
	protected Collection<Algorithm> getAlgorithms() {

		ArrayList<Algorithm> result = new ArrayList<Algorithm>();
		result.add(new ConstraintPanel());
		result.add(new StartCalculationAlgorithmMultiFinalNEW());
		result.add(new StartKnockoutSelection());
		result.add(new StartRobustnesSelection());
		result.add(new StartCalculationAlgorithmFluxVariability());
		return result;
	}

	@Override
	public String getLaunchGuiDescription() {
		return "<html>" +
							"FBA-SimVis provides a variety of methods for the constraint-based analysis<br>" +
							"of metabolic models such as (1) Flux Balance analysis (FBA), (2) Knock-out<br>" +
							" Analysis, (3) Robustness Analysis, and (4) Flux Variability Analysis.<br>" +
							"<br>" +
							"<b>Procedure to perform constraint-based analysis: </b><br>" +
							"<b><font color=\"#04B404\">STEP 1:</font></b>  Specify the model parameters (optinal) <br>" +
							"by selecting the button Parameter Setting<br>" +
							"<br>" +
							"<b><font color=\"#0101DF\">STEP 2:</font></b>  Chose a constraint-based analysis technique <br>" +
							"by selecting the button naming the respective function<br>" +
							"<br>";
	}

	@Override
	public String getName() {
		return "II.  Model Analysis";
	}

	@Override
	public String getCategory() {
		return "FBA";
	}
}
