package de.ipk_gatersleben.ag_pbi.fluxbalance.calculation;

import java.util.ArrayList;
import java.util.Collection;

import org.graffiti.plugin.algorithm.Algorithm;

import de.ipk_gatersleben.ag_nw.graffiti.plugins.gui.launch_gui.LaunchGui;

public class StartKnockoutSelection extends LaunchGui implements Algorithm {

	public StartKnockoutSelection() {
		super();
		algBTsize = ButtonSize.LARGE;
	}

	@Override
	protected Collection<Algorithm> getAlgorithms() {

		ArrayList<Algorithm> result = new ArrayList<Algorithm>();
		result.add(new StartCalculationAlgorithmDeletionComplete());
		result.add(new StartCalculationAlgorithmDeletionNew());

		return result;
	}

	@Override
	public String getLaunchGuiDescription() {
		return "<html>" +
							"FBA-SimVis provides two modes of data evaluation with respect to<br>" +
							"knock-out analysis:<br>" +
							"<br>" +
							"<b><font color=\"#04B404\">(1) Knock-out Analysis (complete):</font></b><br>" +
							"This option allows to perform knock-out analysis based on all re-<br>" +
							"actions of the given network map, thus offering an overview per-<br>" +
							"spective. To perform the analysis, please press the respective <br>" +
							"function button.<br>" +
							"<br>" +
							"<b><font color=\"#0101DF\">(2) Knock-out Analysis (specified):</font></b><br>" +
							"This option allows to perform knock-out analysis based on selected<br>" +
							"reactions specified by the user. To perform the analysis, please<br>" +
							"select first the reactions to be deleted by clicking on the corres-<br>" +
							"ponding reaction nodes in the graph and then start the computa-<br>" +
							"tion by pressing the respective function button.<br>" +
							"<br>";
	}

	@Override
	public String getName() {

		// return "Knock-out Analysis";

		return "<html>" +
							"<font color=\"#0101DF\">Knock-out Analysis</font>";

	}

	@Override
	public String getCategory() {
		return "FBA";
	}
}
