/*******************************************************************************
 * Copyright (c) 2008 Plant Bioinformatics Group, IPK Gatersleben
 *******************************************************************************/
package de.ipk_gatersleben.ag_pbi.fluxbalance.reconstruction;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.ErrorMsg;
import org.graffiti.editor.MainFrame;

public class Cmatrix {
	
	public void getFiles(File file, String path) throws IOException {
		
		FileReader myFile = null;
		BufferedReader buff = null;
		final List<String> lines = new ArrayList<String>();
		
		try {
			myFile = new FileReader(file);
			buff = new BufferedReader(myFile);
			String line;
			
			while ((line = buff.readLine()) != null) {
				lines.add(line);
			}
			
		} catch (IOException e) {
			ErrorMsg.addErrorMessage(e);
		} finally {
			try {
				buff.close();
				myFile.close();
			} catch (IOException e) {
				ErrorMsg.addErrorMessage(e);
			}
		}
		
		final String[][] valuesArray = new String[lines.size()][];
		int cnt = 0;
		for (final String line : lines) {
			valuesArray[cnt++] = line.split(";");
		}
		
		int col = valuesArray[0].length;
		
		int row = lines.size();
		
		// Einlesen in VM, NM Datei
		String pathNM = path + "NM.txt";
		String pathVM = path + "VM.txt";
		BufferedWriter fileNM = new BufferedWriter(new FileWriter(pathNM));
		BufferedWriter fileVM = new BufferedWriter(new FileWriter(pathVM));
		for (int j = 0; j < col; j++) {
			for (int i = 0; i < row; i++) {
				if (isEven(j) == true) {
					fileNM.write(valuesArray[i][j]);
					fileNM.newLine();
				} else {
					fileVM.write(valuesArray[i][j]);
					fileVM.newLine();
				}
			}
		}
		fileNM.close();
		fileVM.close();
	}
	
	public String[][] getFilesAndArray(File file, String path) throws IOException {
		
		FileReader myFile = null;
		BufferedReader buff = null;
		final List<String> lines = new ArrayList<String>();
		
		try {
			myFile = new FileReader(file);
			buff = new BufferedReader(myFile);
			String line;
			
			while ((line = buff.readLine()) != null) {
				lines.add(line);
			}
			
		} catch (IOException e) {
			ErrorMsg.addErrorMessage(e);
		} finally {
			try {
				buff.close();
				myFile.close();
			} catch (IOException e) {
				ErrorMsg.addErrorMessage(e);
			}
		}
		String[][] rctNameArray = new String[3][lines.size()];
		final String[][] valuesArray = new String[lines.size()][];
		int cnt = 0;
		for (final String line : lines) {
			valuesArray[cnt++] = line.split(";");
		}
		
		int col = valuesArray[0].length;
		int row = lines.size();
		
		// Einlesen in VM, NM Datei
		String pathNM = path + "NM.txt";
		String pathVM = path + "VM.txt";
		BufferedWriter fileNM = new BufferedWriter(new FileWriter(pathNM));
		BufferedWriter fileVM = new BufferedWriter(new FileWriter(pathVM));
		
		for (int j = 0; j < col; j++) {
			for (int i = 0; i < row; i++) {
				if (isEven(j) == true) {
					fileNM.write(valuesArray[i][j]);
					fileNM.newLine();
				} else {
					fileVM.write(valuesArray[i][j]);
					fileVM.newLine();
					
				}
				if (j == 0) {
					String name = valuesArray[i][j];
					int index = name.indexOf("^", 0);
					
					if (index == -1) {
						MainFrame.showMessageDialog("Please check the \"C-matrix\"-file: uncorrect format!", "Error");
					}
					name = name.substring(0, index);
					rctNameArray[0][i] = name;
				}
			}
		}
		fileNM.close();
		fileVM.close();
		return rctNameArray;
	}
	
	public String[][] getArray(File file, String path) throws IOException {
		
		FileReader myFile = null;
		BufferedReader buff = null;
		final List<String> lines = new ArrayList<String>();
		
		try {
			myFile = new FileReader(file);
			buff = new BufferedReader(myFile);
			String line;
			while ((line = buff.readLine()) != null) {
				lines.add(line);
			}
			
		} catch (IOException e) {
			ErrorMsg.addErrorMessage(e);
		} finally {
			try {
				buff.close();
				myFile.close();
			} catch (IOException e) {
				ErrorMsg.addErrorMessage(e);
			}
		}
		String[][] rctNameArray = new String[3][lines.size()];
		final String[][] valuesArray = new String[lines.size()][];
		int cnt = 0;
		for (final String line : lines) {
			valuesArray[cnt++] = line.split(";");
		}
		
		int row = lines.size();
		for (int i = 0; i < row; i++) {
			String name = valuesArray[i][0];
			int index = name.indexOf("^", 0);
			
			if (index == -1) {
				MainFrame.showMessageDialog("Please check the \"C-matrix\"-file: incorrect format!", "Error");
			}
			name = name.substring(0, index);
			rctNameArray[0][i] = name;
		}
		return rctNameArray;
	}
	
	static boolean isEven(int wert) {
		if ((wert % 2) == 0) {
			return true;
		} else {
			return false;
		}
	}
}
