/*******************************************************************************
 * Copyright (c) 2008 Plant Bioinformatics Group, IPK Gatersleben
 *******************************************************************************/
package de.ipk_gatersleben.ag_pbi.fluxbalance.reconstruction;

import org.graffiti.editor.MainFrame;
import org.graffiti.plugin.algorithm.PreconditionException;

import de.ipk_gatersleben.ag_pbi.fluxbalance.startsim.AbstractStartCalculationAlgorithm;

/**
 * @author Eva
 */
public class CreateReactionFile extends AbstractStartCalculationAlgorithm {
	
	public String getName() {
		return "<html>" +
							"<font color=\"#5F04B4\">Create Reaction file</font>";
	}
	
	@Override
	public String getDescription() {
		return "<html>" +
							"<b>With this command you may create a reaction file which <br>" +
							"includes a list of the model reactions and their stoichio-<br>" +
							"metrie as shown in the Example.<br>";
	}
	
	@Override
	public void check() throws PreconditionException {
		
		super.check();
		PreconditionException errors = new PreconditionException();
		
		checkForCorrectShapes(errors, graph);
		
		checkForUnconnectedNodes(errors, graph);
		
		if (!errors.isEmpty()) {
			throw errors;
		}
	}
	
	public void execute() {
		new Reactionfile(graph);
		// MainFrame.showMessage("Reaction file created", MessageType.INFO);
		MainFrame.showMessageDialog("Reaction file created", "Information");
	}
	
	@Override
	protected String getImageFileName() {
		return "rctFile12.png";
	}
}