package de.ipk_gatersleben.ag_pbi.fluxbalance.visualization;

import info.clearthought.layout.TableLayout;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Iterator;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.ErrorMsg;
import org.graffiti.editor.MainFrame;
import org.graffiti.graph.GraphElement;
import org.graffiti.plugin.algorithm.AbstractAlgorithm;
import org.graffiti.plugin.algorithm.PreconditionException;
import org.graffiti.plugin.parameter.ObjectListParameter;
import org.graffiti.plugin.parameter.Parameter;
import org.graffiti.selection.Selection;

import de.ipk_gatersleben.ag_nw.graffiti.MyInputHelper;
import de.ipk_gatersleben.ag_nw.graffiti.plugins.gui.editing_tools.script_helper.ConditionInterface;
import de.ipk_gatersleben.ag_nw.graffiti.plugins.gui.editing_tools.script_helper.GraphElementHelper;
import de.ipk_gatersleben.ag_nw.graffiti.plugins.gui.editing_tools.script_helper.SampleInterface;
import de.ipk_gatersleben.ag_nw.graffiti.plugins.gui.editing_tools.script_helper.SubstanceInterface;
import de.ipk_gatersleben.ag_pbi.fluxbalance.startsim.FBAHelper;

public class AnimatedFluxVisualizationSliderMultiFinal2 extends AbstractAlgorithm {
	
	private String parameter1;
	private String parameter2;
	private String parameter3;
	
	private int varMin1;
	private int varMax1;
	
	private int varMin2;
	private int varMax2;
	
	private int varMin3;
	// private int varMax3;
	
	private int noTicks1;
	private int noTicks2;
	
	public void execute() {
		try {
			// min, max values berechnen von gesamten Ergebnissen
			double minValue = Double.MAX_VALUE;
			double maxValue = Double.MIN_VALUE;
			
			for (GraphElement ge : graph.getGraphElements()) {
				GraphElementHelper geh = new GraphElementHelper(ge);
				for (SubstanceInterface md : geh.getDataMappings()) {
					for (ConditionInterface sd : md) {
						for (SampleInterface sampleData : sd) {
							double avg = Math.abs(sampleData.calcMean());
							if (!Double.isNaN(avg)) {
								// if (avg<minValue)
								// minValue = avg;
								if (avg > maxValue)
									maxValue = avg;
							}
						}
					}
				}
			}
			minValue = 0;
			
			// final Collection<String> seriesList = StartSimulationAlgorithm.getSeriesNames(getSelectedOrAllGraphElements());
			final Collection<String> seriesList = StartSimulationAlgorithm.getSeriesNames(graph.getGraphElements());
			
			if (seriesList == null || seriesList.size() == 0) {
				MainFrame.showMessageDialog("No series data available. Cannot proceed!", "Error");
				return;
			}
			
			// Label Parameter & min max values setzen
			Iterator<String> it = seriesList.iterator();
			String label = it.next();
			
			int index1 = label.indexOf("_", 0);
			int fromIndex = 0;
			int index1b = 0;
			int INDEX1B = label.indexOf("%", 0);
			int anzahl = 0;
			for (int i = 0; i < label.length(); i++) {
				
				index1b = label.indexOf("%", fromIndex);
				if (index1b == -1) {
					i = label.length();
				} else {
					fromIndex = index1b + 1;
					anzahl = i + 1;
				}
			}
			int ANZAHL = anzahl + 1;
			
			JSlider slider1 = null;
			JSlider slider2 = null;
			JSlider slider3 = null;
			
			System.out.println("label: " + label);
			
			if (index1 == -1) {
				
				int index2 = label.lastIndexOf("/", label.length());
				String label2;
				if (index2 == -1) {
					label2 = label;
				} else {
					label2 = label.substring(0, index2);
				}
				
				if (label2.equals("noVPrct")) {
					label = label2;
				} else {
					MainFrame.showMessageDialog("Please chose the correct \"Flux data\"-file!", "Error");
					return;
				}
			}
			
			// kein Parameter
			if (INDEX1B == -1 && label.equals("noVPrct")) {
				
				ArrayList<JComponent> buttons = new ArrayList<JComponent>();
				
				for (String series : seriesList) {
					JComponent commandButton = getCommandButton(series, seriesList, minValue, maxValue);
					
					buttons.add(commandButton);
				}
				JComponent buttonPanel = TableLayout.getMultiSplit(buttons);
				
				MyInputHelper.getInput("[nonmodal,Close]Click any button to visualise corresponding flux distribution!", "Flux Visualisation",
									new Object[] {
														"Flux distribution", buttonPanel
				});
				
			} else { // 1 PArameter und mehr: 1 Slider
				if (ANZAHL >= 1) {
					
					int index3;
					String max1;
					Hashtable<Integer, JLabel> labelTable1 = new Hashtable<Integer, JLabel>();
					parameter1 = label.substring(0, index1);
					int index2 = label.indexOf("_", index1 + 1);
					String min1 = label.substring(index1 + 1, index2);
					varMin1 = new Integer(min1).intValue();
					Integer varMin1save = varMin1;
					
					if (ANZAHL == 1) {
						index3 = label.indexOf("<*>", index2 + 1);
						max1 = label.substring(index2 + 1, index3);
						varMax1 = new Integer(max1).intValue();
					} else {
						index3 = label.indexOf("%", index2 + 1);
						max1 = label.substring(index2 + 1, index3);
						varMax1 = new Integer(max1).intValue();
					}
					
					noTicks1 = (varMax1 - varMin1 + 1);
					int[] valArray1 = new int[noTicks1];
					
					for (int i = 0; i < valArray1.length; i++) {
						String paraLabel1 = Integer.toString(varMin1);
						labelTable1.put(new Integer(varMin1), new JLabel(paraLabel1));
						valArray1[i] = varMin1;
						varMin1++;
					}
					
					slider1 = createSlider(seriesList, labelTable1, varMin1save, varMax1, noTicks1);
					
					if (ANZAHL >= 2) {
						
						int index6;
						Hashtable<Integer, JLabel> labelTable2 = new Hashtable<Integer, JLabel>();
						int index4 = label.indexOf("_", index3 + 1);
						parameter2 = label.substring(index3 + 1, index4);
						int index5 = label.indexOf("_", index4 + 1);
						String min2 = label.substring(index4 + 1, index5);
						varMin2 = new Integer(min2).intValue();
						Integer varMin2save = varMin2;
						
						if (ANZAHL == 2) {
							index6 = label.indexOf("<", index5 + 1);
							String max2 = label.substring(index5 + 1, index6);
							varMax2 = new Integer(max2).intValue();
						} else {
							index6 = label.indexOf("%", index5 + 1);
							String max2 = label.substring(index5 + 1, index6);
							varMax2 = new Integer(max2).intValue();
						}
						
						noTicks2 = (varMax2 - varMin2 + 1);
						int[] valArray2 = new int[noTicks2];
						
						for (int i = 0; i < valArray2.length; i++) {
							// labelTable.put(new Integer(varMin1), new JLabel(series));
							String paraLabel2 = Integer.toString(varMin2);
							labelTable2.put(new Integer(varMin2), new JLabel(paraLabel2));
							valArray2[i] = varMin2;
							varMin2++;
						}
						
						slider2 = createSlider(seriesList, labelTable2, varMin2save, varMax2, noTicks2);
						
						if (ANZAHL == 3) {
							
							Hashtable<Integer, JLabel> labelTable3 = new Hashtable<Integer, JLabel>();
							int index7 = label.indexOf("_", index6 + 1);
							parameter3 = label.substring(index6 + 1, index7);
							int index8 = label.indexOf("_", index7 + 1);
							String min3 = label.substring(index7 + 1, index8);
							varMin3 = new Integer(min3).intValue();
							// int index9 = label.indexOf("<", index8 + 1);
							// String max3 = label.substring(index8 + 1, index9);
							// varMax3 = new Integer(max3).intValue();
							
							// noTicks3 = (varMax3 - varMin3 + 1);
							int[] valArray3 = new int[noTicks2];
							
							for (int i = 0; i < valArray3.length; i++) {
								// labelTable.put(new Integer(varMin1), new JLabel(series));
								String paraLabel3 = Integer.toString(varMin2);
								labelTable3.put(new Integer(varMin2), new JLabel(paraLabel3));
								valArray3[i] = varMin3;
								varMin3++;
							}
							
							slider3 = createSlider(seriesList, labelTable2, varMin2save, varMax2, noTicks2);
						}// if Anzahl==3
					}// if Anzahl>=2
				}// if Anzahl>=1
				
				if (slider1 != null)
					slider1.addChangeListener(getChangeListener(slider1, slider2, slider3, seriesList, minValue, maxValue));
				
				if (slider2 != null)
					slider2.addChangeListener(getChangeListener(slider1, slider2, slider3, seriesList, minValue, maxValue));
				
				if (slider3 != null)
					slider3.addChangeListener(getChangeListener(slider1, slider2, slider3, seriesList, minValue, maxValue));
				
				if (ANZAHL == 1) {
					MyInputHelper.getInput("[nonmodal,Close]Constrain fluxes to visualise corresponding flux distribution", "Flux Visualisation",
										new Object[] {
															parameter1, slider1,
					});
				}
				
				if (ANZAHL == 2) {
					MyInputHelper.getInput("[nonmodal,Close]Constrain fluxes to visualise corresponding flux distribution", "Flux Visualisation",
										new Object[] {
															parameter1, slider1,
															parameter2, slider2
					});
				}
				
				if (ANZAHL == 3) {
					MyInputHelper.getInput("[nonmodal,Close]Constrain fluxes to visualise corresponding flux distribution", "Flux Visualisation",
										new Object[] {
															parameter1, slider1,
															parameter2, slider2,
															parameter3, slider3
					});
				}
				
				// createToolTipText(graph, graph.getEdges());
			}
		} catch (Exception e) {
			ErrorMsg.addErrorMessage(e);
		}
	}
	
	private ChangeListener getChangeListener(final JSlider slider1, final JSlider slider2, final JSlider slider3,
						final Collection<String> seriesList, final double minVal, final double maxVal) {
		return new ChangeListener() {
			public void stateChanged(ChangeEvent ce) {
				JSlider activeSlider = (JSlider) ce.getSource();
				
				// entspricht currentSeries
				StringBuilder out = new StringBuilder();
				
				if (!activeSlider.getValueIsAdjusting()) {
					
					if (slider1 != null) {
						int value1 = slider1.getValue();
						String str1 = Integer.toString(value1);
						str1 = ("P" + str1);
						out.append(str1);
					}
					if (slider2 != null) {
						int value2 = slider2.getValue();
						String str2 = Integer.toString(value2);
						str2 = ("_Q" + str2);
						out.append(str2);
					}
					if (slider3 != null) {
						int value3 = slider3.getValue();
						String str3 = Integer.toString(value3);
						str3 = ("_R" + str3);
						out.append(str3);
					}
					
					StartSimulationAlgorithm sa = new StartSimulationAlgorithm(minVal, maxVal);
					sa.attach(FBAHelper.getGraph(), new Selection("none"));
					sa.setParameters(new Parameter[] {
										new ObjectListParameter(out.toString(), "Simulationsparameter", "", seriesList)
					});
					try {
						sa.check();
						sa.execute();
					} catch (PreconditionException e1) {
						ErrorMsg.addErrorMessage(e1);
					}
				}
			}
		};
	}
	
	private JSlider createSlider(final Collection<String> allSeries, final Hashtable<Integer, JLabel> labelTable, final int varMin, final int varMax,
			final int noTicks) {
		JSlider slider = new JSlider();
		slider.setMinimum(varMin);
		slider.setMaximum(varMax);
		slider.setMinorTickSpacing(1);
		slider.setMajorTickSpacing(noTicks);
		slider.setPaintLabels(true);
		slider.setPaintTicks(true);
		slider.setLabelTable(labelTable);
		slider.setValue(varMin);
		slider.setSnapToTicks(true);
		
		return slider;
	}
	
	private JComponent getCommandButton(final String series, final Collection<String> allSeries, final double minVal, final double maxVal) {
		
		JButton button = new JButton("Optimal growth conditions");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				StartSimulationAlgorithm sa = new StartSimulationAlgorithm(minVal, maxVal);
				sa.attach(FBAHelper.getGraph(), new Selection("none"));
				
				sa.setParameters(new Parameter[] {
									new ObjectListParameter(series, "Simulationsparameter", "", allSeries)
				});
				
				try {
					sa.check();
					sa.execute();
				} catch (PreconditionException e1) {
					ErrorMsg.addErrorMessage(e1);
				}
			}
		});
		return button;
	}
	
	@Override
	public String getCategory() {
		return "FBA";
	}
	
	public String getName() {
		// return "Multi Parameter Variation";
		return "<html><font color=\"#5FB404\">Flux Balance Analysis</font>";
	}
}
